// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from gazebo_video_monitor_interfaces:srv/SetCamera.idl
// generated code does not contain a copyright notice

#ifndef GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__SET_CAMERA__STRUCT_H_
#define GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__SET_CAMERA__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'camera_name'
// Member 'model_name'
// Member 'link_name'
#include "rosidl_runtime_c/string.h"
// Member 'pose'
#include "gazebo_video_monitor_interfaces/msg/detail/pose__struct.h"

/// Struct defined in srv/SetCamera in the package gazebo_video_monitor_interfaces.
typedef struct gazebo_video_monitor_interfaces__srv__SetCamera_Request
{
  /// Name of the camera (as given in the SDF description)
  rosidl_runtime_c__String camera_name;
  /// Name of the model with which to associate the camera. If empty, the camera is attached to the world model (see multicamera bootstrapper)
  rosidl_runtime_c__String model_name;
  /// Name of the link to which to attach the camera
  rosidl_runtime_c__String link_name;
  /// Pose relative to the parent link
  gazebo_video_monitor_interfaces__msg__Pose pose;
} gazebo_video_monitor_interfaces__srv__SetCamera_Request;

// Struct for a sequence of gazebo_video_monitor_interfaces__srv__SetCamera_Request.
typedef struct gazebo_video_monitor_interfaces__srv__SetCamera_Request__Sequence
{
  gazebo_video_monitor_interfaces__srv__SetCamera_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} gazebo_video_monitor_interfaces__srv__SetCamera_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'message'
// already included above
// #include "rosidl_runtime_c/string.h"

/// Struct defined in srv/SetCamera in the package gazebo_video_monitor_interfaces.
typedef struct gazebo_video_monitor_interfaces__srv__SetCamera_Response
{
  rosidl_runtime_c__String message;
  bool success;
} gazebo_video_monitor_interfaces__srv__SetCamera_Response;

// Struct for a sequence of gazebo_video_monitor_interfaces__srv__SetCamera_Response.
typedef struct gazebo_video_monitor_interfaces__srv__SetCamera_Response__Sequence
{
  gazebo_video_monitor_interfaces__srv__SetCamera_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} gazebo_video_monitor_interfaces__srv__SetCamera_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__SET_CAMERA__STRUCT_H_
