// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from gazebo_video_monitor_interfaces:msg/Strings.idl
// generated code does not contain a copyright notice

#ifndef GAZEBO_VIDEO_MONITOR_INTERFACES__MSG__DETAIL__STRINGS__TRAITS_HPP_
#define GAZEBO_VIDEO_MONITOR_INTERFACES__MSG__DETAIL__STRINGS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "gazebo_video_monitor_interfaces/msg/detail/strings__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace gazebo_video_monitor_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const Strings & msg,
  std::ostream & out)
{
  out << "{";
  // member: names
  {
    if (msg.names.size() == 0) {
      out << "names: []";
    } else {
      out << "names: [";
      size_t pending_items = msg.names.size();
      for (auto item : msg.names) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Strings & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: names
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.names.size() == 0) {
      out << "names: []\n";
    } else {
      out << "names:\n";
      for (auto item : msg.names) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Strings & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace gazebo_video_monitor_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use gazebo_video_monitor_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const gazebo_video_monitor_interfaces::msg::Strings & msg,
  std::ostream & out, size_t indentation = 0)
{
  gazebo_video_monitor_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use gazebo_video_monitor_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const gazebo_video_monitor_interfaces::msg::Strings & msg)
{
  return gazebo_video_monitor_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<gazebo_video_monitor_interfaces::msg::Strings>()
{
  return "gazebo_video_monitor_interfaces::msg::Strings";
}

template<>
inline const char * name<gazebo_video_monitor_interfaces::msg::Strings>()
{
  return "gazebo_video_monitor_interfaces/msg/Strings";
}

template<>
struct has_fixed_size<gazebo_video_monitor_interfaces::msg::Strings>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<gazebo_video_monitor_interfaces::msg::Strings>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<gazebo_video_monitor_interfaces::msg::Strings>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // GAZEBO_VIDEO_MONITOR_INTERFACES__MSG__DETAIL__STRINGS__TRAITS_HPP_
