// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from gazebo_video_monitor_interfaces:srv/StartGmcmRecording.idl
// generated code does not contain a copyright notice

#ifndef GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__START_GMCM_RECORDING__TRAITS_HPP_
#define GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__START_GMCM_RECORDING__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "gazebo_video_monitor_interfaces/srv/detail/start_gmcm_recording__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'cameras'
#include "gazebo_video_monitor_interfaces/msg/detail/strings__traits.hpp"

namespace gazebo_video_monitor_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const StartGmcmRecording_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: cameras
  {
    out << "cameras: ";
    to_flow_style_yaml(msg.cameras, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StartGmcmRecording_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: cameras
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cameras:\n";
    to_block_style_yaml(msg.cameras, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StartGmcmRecording_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace gazebo_video_monitor_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use gazebo_video_monitor_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  gazebo_video_monitor_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use gazebo_video_monitor_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request & msg)
{
  return gazebo_video_monitor_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request>()
{
  return "gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request";
}

template<>
inline const char * name<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request>()
{
  return "gazebo_video_monitor_interfaces/srv/StartGmcmRecording_Request";
}

template<>
struct has_fixed_size<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request>
  : std::integral_constant<bool, has_fixed_size<gazebo_video_monitor_interfaces::msg::Strings>::value> {};

template<>
struct has_bounded_size<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request>
  : std::integral_constant<bool, has_bounded_size<gazebo_video_monitor_interfaces::msg::Strings>::value> {};

template<>
struct is_message<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace gazebo_video_monitor_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const StartGmcmRecording_Response & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const StartGmcmRecording_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const StartGmcmRecording_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace gazebo_video_monitor_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use gazebo_video_monitor_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  gazebo_video_monitor_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use gazebo_video_monitor_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response & msg)
{
  return gazebo_video_monitor_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response>()
{
  return "gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response";
}

template<>
inline const char * name<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response>()
{
  return "gazebo_video_monitor_interfaces/srv/StartGmcmRecording_Response";
}

template<>
struct has_fixed_size<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<gazebo_video_monitor_interfaces::srv::StartGmcmRecording>()
{
  return "gazebo_video_monitor_interfaces::srv::StartGmcmRecording";
}

template<>
inline const char * name<gazebo_video_monitor_interfaces::srv::StartGmcmRecording>()
{
  return "gazebo_video_monitor_interfaces/srv/StartGmcmRecording";
}

template<>
struct has_fixed_size<gazebo_video_monitor_interfaces::srv::StartGmcmRecording>
  : std::integral_constant<
    bool,
    has_fixed_size<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request>::value &&
    has_fixed_size<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response>::value
  >
{
};

template<>
struct has_bounded_size<gazebo_video_monitor_interfaces::srv::StartGmcmRecording>
  : std::integral_constant<
    bool,
    has_bounded_size<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request>::value &&
    has_bounded_size<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response>::value
  >
{
};

template<>
struct is_service<gazebo_video_monitor_interfaces::srv::StartGmcmRecording>
  : std::true_type
{
};

template<>
struct is_service_request<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Request>
  : std::true_type
{
};

template<>
struct is_service_response<gazebo_video_monitor_interfaces::srv::StartGmcmRecording_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // GAZEBO_VIDEO_MONITOR_INTERFACES__SRV__DETAIL__START_GMCM_RECORDING__TRAITS_HPP_
